Index: trunk/src/VBox/HostDrivers/VBoxPci/VBoxPci.c
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxPci/VBoxPci.c	(revision 36616)
+++ trunk/src/VBox/HostDrivers/VBoxPci/VBoxPci.c	(revision 36621)
@@ -167,5 +167,5 @@
  * @copydoc RAWPCIDEVPORT:: pfnInit
  */
-DECLHIDDEN(int) vboxPciDevInit(PRAWPCIDEVPORT pPort, uint32_t fFlags)
+static DECLCALLBACK(int) vboxPciDevInit(PRAWPCIDEVPORT pPort, uint32_t fFlags)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -184,5 +184,5 @@
  * @copydoc RAWPCIDEVPORT:: pfnDeinit
  */
-DECLHIDDEN(int) vboxPciDevDeinit(PRAWPCIDEVPORT pPort, uint32_t fFlags)
+static DECLCALLBACK(int) vboxPciDevDeinit(PRAWPCIDEVPORT pPort, uint32_t fFlags)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -209,5 +209,5 @@
  * @copydoc RAWPCIDEVPORT:: pfnDestroy
  */
-DECLHIDDEN(int) vboxPciDevDestroy(PRAWPCIDEVPORT pPort)
+static DECLCALLBACK(int) vboxPciDevDestroy(PRAWPCIDEVPORT pPort)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -241,10 +241,10 @@
  * @copydoc RAWPCIDEVPORT:: pfnGetRegionInfo
  */
-DECLHIDDEN(int) vboxPciDevGetRegionInfo(PRAWPCIDEVPORT pPort,
-                                        int32_t        iRegion,
-                                        RTHCPHYS       *pRegionStart,
-                                        uint64_t       *pu64RegionSize,
-                                        bool           *pfPresent,
-                                        uint32_t        *pfFlags)
+static DECLCALLBACK(int) vboxPciDevGetRegionInfo(PRAWPCIDEVPORT pPort,
+                                                 int32_t        iRegion,
+			 			 RTHCPHYS       *pRegionStart,
+				  		 uint64_t       *pu64RegionSize,
+					   	 bool           *pfPresent,
+						 uint32_t        *pfFlags)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -264,10 +264,10 @@
  * @copydoc RAWPCIDEVPORT:: pfnMapRegion
  */
-DECLHIDDEN(int) vboxPciDevMapRegion(PRAWPCIDEVPORT pPort,
-                                    int32_t        iRegion,
-                                    RTHCPHYS       RegionStart,
-                                    uint64_t       u64RegionSize,
-                                    int32_t        fFlags,
-                                    RTR0PTR        *pRegionBase)
+static DECLCALLBACK(int) vboxPciDevMapRegion(PRAWPCIDEVPORT pPort,
+                                             int32_t        iRegion,
+			  		     RTHCPHYS       RegionStart,
+				   	     uint64_t       u64RegionSize,
+					     int32_t        fFlags,
+					     RTR0PTR        *pRegionBase)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -286,9 +286,9 @@
  * @copydoc RAWPCIDEVPORT:: pfnUnapRegion
  */
-DECLHIDDEN(int) vboxPciDevUnmapRegion(PRAWPCIDEVPORT pPort,
-                                      int32_t        iRegion,
-                                      RTHCPHYS       RegionStart,
-                                      uint64_t       u64RegionSize,
-                                      RTR0PTR        RegionBase)
+static DECLCALLBACK(int) vboxPciDevUnmapRegion(PRAWPCIDEVPORT pPort,
+                                               int32_t        iRegion,
+			  		       RTHCPHYS       RegionStart,
+				   	       uint64_t       u64RegionSize,
+					       RTR0PTR        RegionBase)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -307,5 +307,5 @@
  * @copydoc RAWPCIDEVPORT:: pfnPciCfgRead
  */
-DECLHIDDEN(int) vboxPciDevPciCfgRead(PRAWPCIDEVPORT pPort, uint32_t Register, PCIRAWMEMLOC      *pValue)
+static DECLCALLBACK(int) vboxPciDevPciCfgRead(PRAWPCIDEVPORT pPort, uint32_t Register, PCIRAWMEMLOC *pValue)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -325,5 +325,5 @@
  * @copydoc RAWPCIDEVPORT:: pfnPciCfgWrite
  */
-DECLHIDDEN(int) vboxPciDevPciCfgWrite(PRAWPCIDEVPORT pPort, uint32_t Register, PCIRAWMEMLOC *pValue)
+static DECLCALLBACK(int) vboxPciDevPciCfgWrite(PRAWPCIDEVPORT pPort, uint32_t Register, PCIRAWMEMLOC *pValue)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -339,5 +339,5 @@
 }
 
-DECLHIDDEN(int) vboxPciDevRegisterIrqHandler(PRAWPCIDEVPORT pPort, PFNRAWPCIISR pfnHandler, void* pIrqContext, PCIRAWISRHANDLE *phIsr)
+static DECLCALLBACK(int) vboxPciDevRegisterIrqHandler(PRAWPCIDEVPORT pPort, PFNRAWPCIISR pfnHandler, void* pIrqContext, PCIRAWISRHANDLE *phIsr)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -371,5 +371,5 @@
 }
 
-DECLHIDDEN(int) vboxPciDevUnregisterIrqHandler(PRAWPCIDEVPORT pPort, PCIRAWISRHANDLE hIsr)
+static DECLCALLBACK(int) vboxPciDevUnregisterIrqHandler(PRAWPCIDEVPORT pPort, PCIRAWISRHANDLE hIsr)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);
@@ -393,5 +393,5 @@
 }
 
-DECLHIDDEN(int) vboxPciDevPowerStateChange(PRAWPCIDEVPORT pPort, PCIRAWPOWERSTATE  aState, uint64_t *pu64Param)
+static DECLCALLBACK(int) vboxPciDevPowerStateChange(PRAWPCIDEVPORT pPort, PCIRAWPOWERSTATE  aState, uint64_t *pu64Param)
 {
     PVBOXRAWPCIINS pThis = DEVPORT_2_VBOXRAWPCIINS(pPort);