Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 36745)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 36746)
@@ -1588,5 +1588,5 @@
     <message>
         <source>Extensions</source>
-        <translation type="unfinished">Extensiones</translation>
+        <translation>Extensiones</translation>
     </message>
 </context>
@@ -1678,9 +1678,9 @@
     <message>
         <source>Reset host combination</source>
-        <translation type="unfinished"></translation>
+        <translation>Reiniciar combinación anfitrión</translation>
     </message>
     <message>
         <source>Resets the key combination used as the host combination in the VM window.</source>
-        <translation type="unfinished"></translation>
+        <translation>Reiniciar la combinación de techas usada como combinación anfitrión en la ventana de MV.</translation>
     </message>
 </context>
@@ -1890,5 +1890,5 @@
     <message>
         <source>Networking</source>
-        <translation type="unfinished"></translation>
+        <translation>Red</translation>
     </message>
 </context>
@@ -2226,5 +2226,5 @@
     <message>
         <source>None</source>
-        <translation type="unfinished"></translation>
+        <translation>Ninguna</translation>
     </message>
 </context>
@@ -4004,5 +4004,5 @@
     <message>
         <source>USB 2.0 is currently enabled for this virtual machine. However this requires the &lt;b&gt;%1&lt;/b&gt; to be installed. Please install the Extension Pack from the VirtualBox download site. After this you will be able to re-enable USB 2.0. It will be disabled in the meantime unless you cancel the current settings changes.</source>
-        <translation type="unfinished"></translation>
+        <translation>USB 2.0 está habilitado para esta máquina virtual. Sin embargo esto requiere que &lt;b&gt;%1&lt;/b&gt; esté instalado. Instale el Paquete de Extensiones desde el sitio de descargas de VirtualBox. Después de esto podrá rehabilitar USB 2.0. Por el momento será deshabilitado a menos que cancele los cambios de preferencias actuales.</translation>
     </message>
 </context>
@@ -8226,5 +8226,5 @@
     <message>
         <source>&apos;%1&apos; is an invalid host-combination code-sequence.</source>
-        <translation type="unfinished"></translation>
+        <translation>«%1» es una combinación de teclas anfitrión inválida.</translation>
     </message>
 </context>
@@ -9808,5 +9808,5 @@
     <message>
         <source>&lt;p&gt;A new version of VirtualBox has been released! Version &lt;b&gt;%1&lt;/b&gt; is available at &lt;a href=&quot;http://www.virtualbox.org/&quot;&gt;virtualbox.org&lt;/a&gt;.&lt;/p&gt;&lt;p&gt;You can download this version using the link:&lt;/p&gt;&lt;p&gt;&lt;a href=%2&gt;%3&lt;/a&gt;&lt;/p&gt;</source>
-        <translation>&lt;p&gt;¡Hay una nueva versión de VirtualBox! La versión &lt;b&gt;%1&lt;/b&gt; se ecuentra disponible en &lt;a href=&quot;http://www.virtualbox.org/&quot;&gt;virtualbox.org&lt;/a&gt;.&lt;/p&gt;&lt;p&gt;Puede descargar dicha versión directamente desde el siguiente enlace:&lt;/p&gt;&lt;p&gt;&lt;a href=%2&gt;%3&lt;/a&gt;&lt;/p&gt;</translation>
+        <translation type="unfinished">&lt;p&gt;¡Hay una nueva versión de VirtualBox! La versión &lt;b&gt;%1&lt;/b&gt; se encuentra disponible en &lt;a href=&quot;http://www.virtualbox.org/&quot;&gt;virtualbox.org&lt;/a&gt;.&lt;/p&gt;&lt;p&gt;Puede descargar dicha versión directamente desde el siguiente enlace:&lt;/p&gt;&lt;p&gt;&lt;a href=%2&gt;%3&lt;/a&gt;&lt;/p&gt;</translation>
     </message>
     <message>
@@ -10447,13 +10447,13 @@
     <message>
         <source>Deletion of all files belonging to the VM is currently disabled on Windows/x64 to prevent a crash. That will be fixed in the next release.</source>
-        <translation type="unfinished"></translation>
+        <translation>La eliminación de todos los archivos pertenecientes a la MV está actualmente deshabilitado en Windows/x64 para prevenir un fallo. Esto será corregido en la siguiente versión.</translation>
     </message>
     <message>
         <source>&lt;p&gt;Cannot create the machine folder &lt;b&gt;%1&lt;/b&gt; in the parent folder &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;Please check that the parent really exists and that you have permissions to create the machine folder.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;No se puede crear la carpeta de la máquina &lt;b&gt;%1&lt;/b&gt; en la carpeta padre &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;Compruebe que la carpeta padre existe y que tiene permisos para crear la carpeta de la máquina.&lt;/p&gt;</translation>
     </message>
     <message>
         <source>&lt;p&gt;USB 2.0 is currently enabled for this virtual machine. However this requires the &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt; to be installed.&lt;/p&gt;&lt;p&gt;Please install the Extension Pack from the VirtualBox download site. After this you will be able to re-enable USB 2.0. It will be disabled in the meantime unless you cancel the current settings changes.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;USB 2.0 está habilitado para esta máquina virtual. Sin embargo esto requiere que &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt; esté instalado.&lt;/p&gt;&lt;p&gt;Instale el Paquete de Extensiones desde el sitio de descargas de VirtualBox. Después de esto podrá rehabilitar USB 2.0. Por el momento será deshabilitado a menos que cancele los cambios de preferencias actuales.&lt;/p&gt;</translation>
     </message>
 </context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 36745)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 36746)
@@ -1143,5 +1143,5 @@
     <message>
         <source>&amp;Extension Packages:</source>
-        <translation>&amp;Papildinių paketai</translation>
+        <translation>&amp;Papildinių paketai:</translation>
     </message>
     <message>
@@ -1179,5 +1179,5 @@
     <message>
         <source>Extensions</source>
-        <translation type="unfinished">Papildiniai</translation>
+        <translation>Papildiniai</translation>
     </message>
 </context>
@@ -1225,9 +1225,9 @@
     <message>
         <source>Host &amp;Key:</source>
-        <translation>Pagrindinis &amp;klavišas:</translation>
+        <translation>Pagr. kompiuterio &amp;klavišas:</translation>
     </message>
     <message>
         <source>Displays the key used as a Host Key in the VM window. Activate the entry field and press a new Host Key. Note that alphanumeric, cursor movement and editing keys cannot be used.</source>
-        <translation>Rodo klavišą, naudojamą kaip pagrindinį klavišą VM lange. Aktyvuokite įvedimo laukelį ir nuspauskite būsimą pagrindinį klavišą. Atminkite, kad negalima priskirti raidžių, skaičių, žymeklio perkėlimo, redagavimo klavišų.</translation>
+        <translation>Rodo klavišą, naudojamą kaip pagrindinio kompiuterio klavišą VM lange. Aktyvuokite įvedimo laukelį ir nuspauskite būsimą pagrindinį klavišą. Atminkite, kad negalima priskirti raidžių, skaičių, žymeklio perkėlimo, redagavimo klavišų.</translation>
     </message>
     <message>
@@ -1249,9 +1249,9 @@
     <message>
         <source>Reset host combination</source>
-        <translation type="unfinished"></translation>
+        <translation>Atstatyti pagr. kompiuterio kombinaciją</translation>
     </message>
     <message>
         <source>Resets the key combination used as the host combination in the VM window.</source>
-        <translation type="unfinished"></translation>
+        <translation>Atstatyti klavišų kombinaciją, kuri naudojama kaip pagrindinio kompiuterio kombinacija VM lange.</translation>
     </message>
 </context>
@@ -1447,5 +1447,5 @@
     <message>
         <source>Networking</source>
-        <translation type="unfinished"></translation>
+        <translation>Tinklas</translation>
     </message>
 </context>
@@ -1783,5 +1783,5 @@
     <message>
         <source>None</source>
-        <translation type="unfinished"></translation>
+        <translation>Nėra</translation>
     </message>
 </context>
@@ -2234,5 +2234,5 @@
     <message>
         <source>You have 3D Acceleration enabled for a operation system which uses the WDDM video driver. For maximal performance set the guest VRAM to at least &lt;b&gt;%1&lt;/b&gt;.</source>
-        <translation type="unfinished"></translation>
+        <translation>Įgalinote 3D spartinimą operacinei sistemai, kuri naudoja WDDM vaizdo tvarkyklę. Didžiausią našumą pasieksite, jei vaizdo laisvosios prieigos atminčiai paskirsite bent &lt;b&gt;%1&lt;/b&gt;. </translation>
     </message>
     <message>
@@ -3010,5 +3010,5 @@
     <message>
         <source>&amp;Chipset:</source>
-        <translation>&amp;Lustų rinkinys</translation>
+        <translation>&amp;Lustų rinkinys:</translation>
     </message>
     <message>
@@ -3264,5 +3264,5 @@
     <message>
         <source>USB 2.0 is currently enabled for this virtual machine. However this requires the &lt;b&gt;%1&lt;/b&gt; to be installed. Please install the Extension Pack from the VirtualBox download site. After this you will be able to re-enable USB 2.0. It will be disabled in the meantime unless you cancel the current settings changes.</source>
-        <translation type="unfinished"></translation>
+        <translation>Šioje virtualioje mašinoje įgalintas USB 2.0. Tačiau tam turi įdiegtas &lt;b&gt;%1&lt;/b&gt;. Įdiegike papildinių paketą, kurį rasite VirtualBox svetainėje. Tuomet vėl galėsite įgalite USB 2.0. Iki tol ši funkcija bus uždrausta, nebent atsisakysite dabartinių nuostatų pakeitimų.</translation>
     </message>
 </context>
@@ -6921,5 +6921,5 @@
     <message>
         <source>&apos;%1&apos; is an invalid host-combination code-sequence.</source>
-        <translation type="unfinished"></translation>
+        <translation>„%1“ yra netinkama pagr. kompiuterio kombinacijos kodo seka.</translation>
     </message>
 </context>
@@ -8319,6 +8319,4 @@
         <translation type="unfinished">
             <numerusform></numerusform>
-            <numerusform></numerusform>
-            <numerusform></numerusform>
         </translation>
     </message>
@@ -8507,13 +8505,13 @@
     <message>
         <source>Deletion of all files belonging to the VM is currently disabled on Windows/x64 to prevent a crash. That will be fixed in the next release.</source>
-        <translation type="unfinished"></translation>
+        <translation>Visų virtuliai mašinai rinkmenų pašalinimas uždraustas Windows/x64 sistemoje tam, kad būtų išvengta strigio. Tai bus ištaisyta sekančiame leidime.</translation>
     </message>
     <message>
         <source>&lt;p&gt;Cannot create the machine folder &lt;b&gt;%1&lt;/b&gt; in the parent folder &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;Please check that the parent really exists and that you have permissions to create the machine folder.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Viršaplankyje &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;&lt;/nobr&gt; nepavyksta sukurti mašinos aplanko &lt;b&gt;%1&lt;/b&gt;.&lt;/p&gt;&lt;p&gt;Patikrinkite, ar viršaplankis iš tiesų yra ir ar turite leidimą kurti mašinos aplanką.&lt;/p&gt;</translation>
     </message>
     <message>
         <source>&lt;p&gt;USB 2.0 is currently enabled for this virtual machine. However this requires the &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt; to be installed.&lt;/p&gt;&lt;p&gt;Please install the Extension Pack from the VirtualBox download site. After this you will be able to re-enable USB 2.0. It will be disabled in the meantime unless you cancel the current settings changes.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Šioje virtualioje mašinoje įgalintas USB 2.0. Tačiau tam turi įdiegtas &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt;. &lt;nobr&gt;Įdiegike papildinių paketą, kurį rasite VirtualBox svetainėje. Tuomet vėl galėsite įgalite USB 2.0. Iki tol ši funkcija bus uždrausta, nebent atsisakysite dabartinių nuostatų pakeitimų.&lt;/p&gt;</translation>
     </message>
 </context>
@@ -8814,5 +8812,5 @@
     <message>
         <source>Creates an Shortcut file to the VirtualBox Machine Definition file on your Desktop.</source>
-        <translation>Darbalaukyje sukuriama šaukinio rinkmeną  į VirtualBox mašinos apibrėžties rinkmeną.</translation>
+        <translation>Darbalaukyje sukuriama šaukinio rinkmeną į VirtualBox mašinos apibrėžties rinkmeną.</translation>
     </message>
     <message>